'use strict';

var CMD4_ACC_TYPE_ENUM =
{
   AccessoryFlags:                        0,
   Active:                                1,
   ActiveIdentifier:                      2,
   AccessoryIdentifier:                   3,
   AdministratorOnlyAccess:               4,
   AirParticulateDensity:                 5,
   AirParticulateSize:                    6,
   AirQuality:                            7,
   AudioFeedback:                         8,
   BatteryLevel:                          9,
   Brightness:                            10,
   CarbonDioxideDetected:                 11,
   CarbonDioxideLevel:                    12,
   CarbonDioxidePeakLevel:                13,
   CarbonMonoxideDetected:                14,
   CarbonMonoxideLevel:                   15,
   CarbonMonoxidePeakLevel:               16,
   Category:                              17,
   ChargingState:                         18,
   ClosedCaptions:                        19,
   ColorTemperature:                      20,
   ConfiguredName:                        21,
   ConfigureBridgedAccessoryStatus:       22,
   ConfigureBridgedAccessory:             23,
   ContactSensorState:                    24,
   CoolingThresholdTemperature:           25,
   CurrentAirPurifierState:               26,
   CurrentAmbientLightLevel:              27,
   CurrentDoorState:                      28,
   CurrentFanState:                       29,
   CurrentHeaterCoolerState:              30,
   CurrentHeatingCoolingState:            31,
   CurrentHorizontalTiltAngle:            32,
   CurrentHumidifierDehumidifierState:    33,
   CurrentMediaState:                     34,
   CurrentPosition:                       35,
   CurrentRelativeHumidity:               36,
   CurrentSlatState:                      37,
   CurrentTemperature:                    38,
   CurrentTiltAngle:                      39,
   CurrentTime:                           40,
   CurrentVerticalTiltAngle:              41,
   CurrentVisibilityState:                42,
   DayoftheWeek:                          43,
   DigitalZoom:                           44,
   DiscoverBridgedAccessories:            45,
   DiscoveredBridgedAccessories:          46,
   DisplayOrder:                          47,
   FilterChangeIndication:                48,
   FilterLifeLevel:                       49,
   FirmwareRevision:                      50,
   HardwareRevision:                      51,
   HeatingThresholdTemperature:           52,
   HoldPosition:                          53,
   Hue:                                   54,
   Identify:                              55,
   Identifier:                            56,
   ImageMirroring:                        57,
   ImageRotation:                         58,
   InputDeviceType:                       59,
   InputSourceType:                       60,
   InUse:                                 61,
   IsConfigured:                          62,
   LeakDetected:                          63,
   LinkQuality:                           64,
   LockControlPoint:                      65,
   LockCurrentState:                      66,
   LockLastKnownAction:                   67,
   LockManagementAutoSecurityTimeout:     68,
   LockPhysicalControls:                  69,
   LockTargetState:                       70,
   Logs:                                  71,
   Manufacturer:                          72,
   Model:                                 73,
   MotionDetected:                        74,
   Mute:                                  75,
   Name:                                  76,
   NightVision:                           77,
   NitrogenDioxideDensity:                78,
   ObstructionDetected:                   79,
   OccupancyDetected:                     80,
   On:                                    81,
   OpticalZoom:                           82,
   OutletInUse:                           83,
   OzoneDensity:                          84,
   PairSetup:                             85,
   PairVerify:                            86,
   PairingFeatures:                       87,
   PairingPairings:                       88,
   PictureMode:                           89,
   PM10Density:                           90,
   PM2_5Density:                          91,
   PositionState:                         92,
   PowerModeSelection:                    93,
   ProgramMode:                           94,
   ProgrammableSwitchEvent:               95,
   ProgrammableSwitchOutputState:         96,
   Reachable:                             97,
   RelativeHumidityDehumidifierThreshold: 98,
   RelativeHumidityHumidifierThreshold:   99,
   RelayEnabled:                          100,
   RelayState:                            101,
   RelayControlPoint:                     102,
   RemainingDuration:                     103,
   RemoteKey:                             104,
   ResetFilterIndication:                 105,
   RotationDirection:                     106,
   RotationSpeed:                         107,
   Saturation:                            108,
   SecuritySystemAlarmType:               109,
   SecuritySystemCurrentState:            110,
   SecuritySystemTargetState:             111,
   SelectedRTPStreamConfiguration:        112,
   SerialNumber:                          113,
   ServiceLabelIndex:                     114,
   ServiceLabelNamespace:                 115,
   SetDuration:                           116,
   SetupEndpoints:                        117,
   SlatType:                              118,
   SleepDiscoveryMode:                    119,
   SmokeDetected:                         120,
   StatusActive:                          121,
   StatusFault:                           122,
   StatusJammed:                          123,
   StatusLowBattery:                      124,
   StatusTampered:                        125,
   StreamingStatus:                       126,
   SulphurDioxideDensity:                 127,
   SupportedAudioStreamConfiguration:     128,
   SupportedRTPConfiguration:             129,
   SupportedVideoStreamConfiguration:     130,
   SwingMode:                             131,
   TargetAirPurifierState:                132,
   TargetAirQuality:                      133,
   TargetDoorState:                       134,
   TargetFanState:                        135,
   TargetHeaterCoolerState:               136,
   TargetHeatingCoolingState:             137,
   TargetHorizontalTiltAngle:             138,
   TargetHumidifierDehumidifierState:     139,
   TargetMediaState:                      140,
   TargetPosition:                        141,
   TargetRelativeHumidity:                142,
   TargetSlatState:                       143,
   TargetTemperature:                     144,
   TargetTiltAngle:                       145,
   TargetVerticalTiltAngle:               146,
   TargetVisibilityState:                 147,
   TemperatureDisplayUnits:               148,
   TimeUpdate:                            149,
   TunneledAccessoryAdvertising:          150,
   TunneledAccessoryConnected:            151,
   TunneledAccessoryStateNumber:          152,
   TunnelConnectionTimeout:               153,
   ValveType:                             154,
   Version:                               155,
   VOCDensity:                            156,
   Volume:                                157,
   VolumeControlType:                     158,
   VolumeSelector:                        159,
   WaterLevel:                            160,
   EOL:                                   161,
   properties: {}
};

// Export both the init function and the uninitialized data for unit testing
module.exports =
{
   init: function (Characteristic)
   {

      // Fill in the properties of all possible characteristics
      // props was added because calling getCharacteridtic().props.perms adds
      // the characteristic in by default. This costs some lines, but is advantageous.
      CMD4_ACC_TYPE_ENUM.properties =
      {
         0:   { type: "AccessoryFlags",
                characteristic: Characteristic.AccessoryFlags,
                props: {format: Characteristic.Formats.UINT32,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         1:   { type: "Active",
                characteristic:Characteristic.Active,
                props:
                   {format: Characteristic.Formats.UINT8,
                    maxValue: 1,
                    minValue: 0,
                    perms: [Characteristic.Perms.READ,
                            Characteristic.Perms.WRITE,
                            Characteristic.Perms.NOTIFY
                           ]
                   },
                validValues:   // Checked 04/24/2020
                   {"INACTIVE": Characteristic.Active.INACTIVE,
                    "ACTIVE":   Characteristic.Active.ACTIVE
                   }
              },
         2:   { type: "ActiveIdentifier",   // HomeKitTypes-Television.js
                characteristic: Characteristic.ActiveIdentifier,
                props: {format: Characteristic.Formats.UINT32,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         3:   { type: "AccessoryIdentifier",   // HomeKitTypes-Bridge.js
                characteristic: Characteristic.AccessoryIdentifier,
                props: {format: Characteristic.Formats.STRING,
                   perms: [Characteristic.Perms.READ
                          ]
                       },
                validValues: {}
              },
         4:   { type: "AdministratorOnlyAccess",
                characteristic: Characteristic.AdministratorOnlyAccess,
                props: {format: Characteristic.Formats.BOOL,
                         perms: [Characteristic.Perms.READ,
                                 Characteristic.Perms.WRITE,
                                 Characteristic.Perms.NOTIFY
                                ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":   true
                   }
              },
         5:   { type: "AirParticulateDensity",
                characteristic: Characteristic.AirParticulateDensity,
                props: {format: Characteristic.Formats.FLOAT,
                      maxValue: 1000,
                      minValue: 0,
                       minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         6:   { type: "AirParticulateSize",
                characteristic: Characteristic.AirParticulateSize,
                props: {format: Characteristic.Formats.UINT8,
                      maxValue: 1,
                      minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:   // Checked 04/24/2020
                   {"_2_5_M": Characteristic.AirParticulateSize._2_5_M,
                    "_10_M":  Characteristic.AirParticulateSize._10_M
                   }
              },
         7:   { type: "AirQuality",
                characteristic: Characteristic.AirQuality,
                props: {format: Characteristic.Formats.UINT8,
                      maxValue: 5,
                      minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:   // Checked 04/24/2020
                   {"UNKNOWN":   Characteristic.AirQuality.UNKNOWN,
                    "EXCELLENT": Characteristic.AirQuality.EXCELLENT,
                              "GOOD":      Characteristic.AirQuality.GOOD,
                              "FAIR":      Characteristic.AirQuality.FAIR,
                              "INFERIOR":  Characteristic.AirQuality.INFERIOR,
                              "POOR":      Characteristic.AirQuality.POOR
                   }
              },
         8:   { type: "AudioFeedback",
                characteristic: Characteristic.AudioFeedback,
                props: {format: Characteristic.Formats.BOOL,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":  true
                   }
              },
         9:   { type: "BatteryLevel",
                characteristic: Characteristic.BatteryLevel,
                props: {format: Characteristic.Formats.UINT8,
                          unit: Characteristic.Units.PERCENTAGE,
                      maxValue: 100,
                      minValue: 0,
                       minStep: 1,
                         perms: [Characteristic.Perms.READ,
                                 Characteristic.Perms.NOTIFY
                                ]
                       },
                validValues: {}
              },
         10:  { type: "Brightness",
                characteristic: Characteristic.Brightness,
                props: {format: Characteristic.Formats.INT,
                          unit: Characteristic.Units.PERCENTAGE,
                        maxValue: 100,
                        minValue: 0,
                         minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         11:  { type: "CarbonDioxideDetected",
                characteristic: Characteristic.CarbonDioxideDetected,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"CO2_LEVELS_NORMAL":
                     Characteristic.CarbonDioxideDetected.CO2_LEVELS_NORMAL,
                    "CO2_LEVELS_ABNORMAL":
                     Characteristic.CarbonDioxideDetected.CO2_LEVELS_ABNORMAL
                   }
              },
         12:  { type: "CarbonDioxideLevel",
                characteristic: Characteristic.CarbonDioxideLevel,
                props: {format: Characteristic.Formats.FLOAT,
                        maxValue: 100000,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         13:  { type: "CarbonDioxidePeakLevel",
                characteristic: Characteristic.CarbonDioxidePeakLevel,
                props: {format: Characteristic.Formats.FLOAT,
                      maxValue: 100000,
                      minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         14:  { type: "CarbonMonoxideDetected",
                characteristic: Characteristic.CarbonMonoxideDetected,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"CO_LEVELS_NORMAL":
                     Characteristic.CarbonMonoxideDetected.CO_LEVELS_NORMAL,
                    "CO_LEVELS_ABNORMAL":
                     Characteristic.CarbonMonoxideDetected.CO_LEVELS_ABNORMAL
                   }
              },
         15:  { type: "CarbonMonoxideLevel",
                characteristic: Characteristic.CarbonMonoxideLevel,
                props: {format: Characteristic.Formats.FLOAT,
                        maxValue: 100,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         16:  { type: "CarbonMonoxidePeakLevel",
                characteristic: Characteristic.CarbonMonoxidePeakLevel,
                props: {format: Characteristic.Formats.FLOAT,
                        maxValue: 100,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         17:  { type: "Category",    // HomeKitTypes-Bridge.js
                characteristic: Characteristic.Category,
                props: {format: Characteristic.Formats.UINT16,
                        maxValue: 16,
                        minValue: 1,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         18:  { type: "ChargingState",
                characteristic: Characteristic.ChargingState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 2,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
            validValues:   // Checked 04/24/2020. Note: HomeKit Spec has inProgress, Not CHARGING
                   {"NOT_CHARGING": Characteristic.ChargingState.NOT_CHARGING,
                    "CHARGING": Characteristic.ChargingState.CHARGING,
                    "NOT_CHARGEABLE":Characteristic.ChargingState.NOT_CHARGEABLE
                   }
              },
         19:  { type: "ClosedCaptions",    // HomeKitTypes-Television.js
                characteristic: Characteristic.ClosedCaptions,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"DISABLED": Characteristic.ClosedCaptions.DISABLED,
                    "ENABLED":  Characteristic.ClosedCaptions.ENABLED
                   }
              },
         20:  { type: "ColorTemperature",
                characteristic: Characteristic.ColorTemperature,
                props: {format: Characteristic.Formats.UINT32,
                        maxValue: 500,
                        minValue: 140,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         21:  { type: "ConfiguredName",    // HomeKitTypes-Television.js
                characteristic: Characteristic.ConfiguredName,
                props: {format: Characteristic.Formats.STRING,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         22:  { type: "ConfigureBridgedAccessoryStatus",    // HomeKitTypes-Bridge.js
                characteristic: Characteristic.ConfigureBridgedAccessoryStatus,
                props: {format: Characteristic.Formats.TLV8,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         23:  { type: "ConfigureBridgedAccessory",    // HomeKitTypes-Bridge.js
                characteristic: Characteristic.ConfigureBridgedAccessory,
                props: {format: Characteristic.Formats.TLV8,
                        perms: [Characteristic.Perms.WRITE
                               ]
                       },
                validValues: {}
              },
         24:  { type: "ContactSensorState",
                characteristic: Characteristic.ContactSensorState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"CONTACT_DETECTED": Characteristic.ContactSensorState.CONTACT_DETECTED,
                    "CONTACT_NOT_DETECTED": Characteristic.ContactSensorState.CONTACT_NOT_DETECTED
                   }
              },
         25:  { type: "CoolingThresholdTemperature",
                characteristic: Characteristic.CoolingThresholdTemperature,
                props: {format: Characteristic.Formats.FLOAT,
                        unit: Characteristic.Units.CELSIUS,
                        maxValue: 35,
                        minValue: 10,
                        minStep: 0.1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         26:  { type: "CurrentAirPurifierState",
                characteristic: Characteristic.CurrentAirPurifierState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 2,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:   // Checked 04/24/2020
                   {"INACTIVE": Characteristic.CurrentAirPurifierState.INACTIVE,
                    "IDLE": Characteristic.CurrentAirPurifierState.IDLE,
                    "PURIFYING_AIR":Characteristic.CurrentAirPurifierState.PURIFYING_AIR
                   }
              },
         27:  { type: "CurrentAmbientLightLevel",
                characteristic: Characteristic.CurrentAmbientLightLevel,
                props: {format: Characteristic.Formats.FLOAT,
                        unit: Characteristic.Units.LUX,
                        maxValue: 100000,
                        minValue: 0.0001,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         28:  { type: "CurrentDoorState",
                characteristic: Characteristic.CurrentDoorState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 4,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"OPEN":    Characteristic.CurrentDoorState.OPEN,
                    "CLOSED":  Characteristic.CurrentDoorState.CLOSED,
                    "OPENING": Characteristic.CurrentDoorState.OPENING,
                    "CLOSING": Characteristic.CurrentDoorState.CLOSING,
                    "STOPPED": Characteristic.CurrentDoorState.STOPPED
                   }
              },
         29:  { type: "CurrentFanState",
                characteristic: Characteristic.CurrentFanState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 2,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"INACTIVE":    Characteristic.CurrentFanState.INACTIVE,
                    "IDLE":        Characteristic.CurrentFanState.IDLE,
                    "BLOWING_AIR": Characteristic.CurrentFanState.BLOWING_AIR
                   }
              },
         30:  { type: "CurrentHeaterCoolerState",
                characteristic: Characteristic.CurrentHeaterCoolerState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 3,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:   // Checked 04/24/2020
                   {"INACTIVE": Characteristic.CurrentHeaterCoolerState.INACTIVE,
                    "IDLE":     Characteristic.CurrentHeaterCoolerState.IDLE,
                    "HEATING":  Characteristic.CurrentHeaterCoolerState.HEATING,
                    "COOLING":  Characteristic.CurrentHeaterCoolerState.COOLING
                   }
              },
         31:  { type: "CurrentHeatingCoolingState",
                characteristic: Characteristic.CurrentHeatingCoolingState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 3,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:   // Checked 04/24/2020
                   {"OFF":  Characteristic.CurrentHeatingCoolingState.OFF,
                    "HEAT": Characteristic.CurrentHeatingCoolingState.HEAT,
                    "COOL": Characteristic.CurrentHeatingCoolingState.COOL,
                    "AUTO": Characteristic.CurrentHeatingCoolingState.AUTO
                   }
              },
         32:  { type: "CurrentHorizontalTiltAngle",
                characteristic: Characteristic.CurrentHorizontalTiltAngle,
                props: {format: Characteristic.Formats.INT,
                        unit: Characteristic.Units.ARC_DEGREE,
                        maxValue: 90,
                        minValue: -90,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         33:  { type: "CurrentHumidifierDehumidifierState",
                characteristic: Characteristic.CurrentHumidifierDehumidifierState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 3,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"INACTIVE":      Characteristic.CurrentHumidifierDehumidifierState.INACTIVE,
                    "IDLE":          Characteristic.CurrentHumidifierDehumidifierState.IDLE,
                    "HUMIDIFYING":   Characteristic.CurrentHumidifierDehumidifierState.HUMIDIFYING,
                    "DEHUMIDIFYING": Characteristic.CurrentHumidifierDehumidifierState.DEHUMIDIFYING
                }
              },
         34:  { type: "CurrentMediaState",   // HomKitTypes-Television.js
                characteristic: Characteristic.CurrentMediaState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 5,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                // HomeKit forgets to define these
                validValues: {"PLAY":        Characteristic.CurrentMediaState.PLAY,
                              "PAUSE":       Characteristic.CurrentMediaState.PAUSE,
                              "STOP":        Characteristic.CurrentMediaState.STOP,
                              "UNKNOWN3":    3,
                              "LOADING":     Characteristic.CurrentMediaState.LOADING,
                              "INTERRUPTED": Characteristic.CurrentMediaState.INTERRUPTED}
              },
         35:  { type: "CurrentPosition",
                characteristic: Characteristic.CurrentPosition,
                props: {format: Characteristic.Formats.UINT8,
                        unit: Characteristic.Units.PERCENTAGE,
                        maxValue: 100,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         36:  { type: "CurrentRelativeHumidity",
                characteristic: Characteristic.CurrentRelativeHumidity,
                props: {format: Characteristic.Formats.FLOAT,
                        unit: Characteristic.Units.PERCENTAGE,
                        maxValue: 100,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         37:  { type: "CurrentSlatState",
                characteristic: Characteristic.CurrentSlatState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 2,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:   // Checked 04/24/2020  Note HomeKit Spec has "Stationary" not "Jammed"
                   {"FIXED":    Characteristic.CurrentSlatState.FIXED,
                    "JAMMED":   Characteristic.CurrentSlatState.JAMMED,
                    "SWINGING": Characteristic.CurrentSlatState.SWINGING
                   }
              },
         38:  { type: "CurrentTemperature",
                characteristic: Characteristic.CurrentTemperature,
                props: {format: Characteristic.Formats.FLOAT,
                        unit: Characteristic.Units.CELSIUS,
                        maxValue: 100,
                        minValue: 0,
                        minStep: 0.1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         39:  { type: "CurrentTiltAngle",
                characteristic: Characteristic.CurrentTiltAngle,
                props: {format: Characteristic.Formats.INT,
                        unit: Characteristic.Units.ARC_DEGREE,
                        maxValue: 90,
                        minValue: -90,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         40:  { type: "CurrentTime",   // HomeKitTypes-Bridge.js
                characteristic: Characteristic.CurrentTime,
                props: {format: Characteristic.Formats.STRING,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE
                               ]
                       },
                validValues: {}
              },
         41:  { type: "CurrentVerticalTiltAngle",
                characteristic: Characteristic.CurrentVerticalTiltAngle,
                props: {format: Characteristic.Formats.INT,
                        unit: Characteristic.Units.ARC_DEGREE,
                        maxValue: 90,
                        minValue: -90,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         42:  { type: "CurrentVisibilityState",    // HomeKitTypes-Television.js
                characteristic: Characteristic.CurrentVisibilityState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 3,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                            },
                validValues:
                   {"SHOWN":    Characteristic.CurrentVisibilityState.SHOWN,
                    "HIDDEN":   Characteristic.CurrentVisibilityState.HIDDEN,
                    "UNKNOWN2": 2,   // HomeBridge defines 4 valid values
                    "UNKNOWN3": 3
                   }
              },
         43:  { type: "DayoftheWeek",    // HomeKitTypes-Bridge.js
                characteristic: Characteristic.DayoftheWeek,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 7,
                        minValue: 1,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE
                               ]
                       },
                validValues: {}
              },
         44:  { type: "DigitalZoom",
                characteristic: Characteristic.DigitalZoom,
                props: {format: Characteristic.Formats.FLOAT,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         45:  { type: "DiscoverBridgedAccessories",   // HomKitTypes-Bridge.js
                characteristic: Characteristic.DiscoverBridgedAccessories,
                props: {format: Characteristic.Formats.UINT8,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:{}
              },
         46:  { type: "DiscoveredBridgedAccessories",   // HomKitTypes-Bridge.js
                characteristic: Characteristic.DiscoveredBridgedAccessories,
                props: {format: Characteristic.Formats.UINT16,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         47:  { type: "DisplayOrder",   // HomKitTypes-Television.js
                characteristic: Characteristic.DisplayOrder,
                props: {format: Characteristic.Formats.TLV8,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         48:  { type: "FilterChangeIndication",
                characteristic: Characteristic.FilterChangeIndication,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:   // Checked 04/24/2020.  HomeKit Spec has these as "notNeeded" and "needed"
                   {"FILTER_OK": Characteristic.FilterChangeIndication.FILTER_OK,
                    "CHANGE_FILTER":Characteristic.FilterChangeIndication.CHANGE_FILTER
                   }
              },
         49:  { type: "FilterLifeLevel",
                characteristic: Characteristic.FilterLifeLevel,
                props: {format: Characteristic.Formats.FLOAT,
                        maxValue: 100,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         50:  { type: "FirmwareRevision",
                characteristic: Characteristic.FirmwareRevision,
                props: {format: Characteristic.Formats.STRING,
                   perms: [Characteristic.Perms.READ
                          ]
                       },
                validValues: {}
              },
         51:  { type: "HardwareRevision",
                characteristic: Characteristic.HardwareRevision,
                props: {format: Characteristic.Formats.STRING,
                   perms: [Characteristic.Perms.READ
                          ]
                       },
                validValues: {}
              },
         52:  { type: "HeatingThresholdTemperature",
                characteristic: Characteristic.HeatingThresholdTemperature,
                props: {format: Characteristic.Formats.FLOAT,
                        unit: Characteristic.Units.CELSIUS,
                        maxValue: 25,
                        minValue: 0,
                        minStep: 0.1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         53:  { type: "HoldPosition",
                characteristic: Characteristic.HoldPosition,
                props: {format: Characteristic.Formats.BOOL,
                        perms: [Characteristic.Perms.WRITE
                               ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":  true
                   }
              },
         54:  { type: "Hue",
                characteristic: Characteristic.Hue,
                props: {format: Characteristic.Formats.FLOAT,
                        unit: Characteristic.Units.ARC_DEGREE,
                        maxValue: 360,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         55:  { type: "Identify",
                characteristic: Characteristic.Identify,
                props: {format: Characteristic.Formats.BOOL,
                   perms: [Characteristic.Perms.WRITE
                          ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":  true
                   }
              },
         56:  { type: "Identifier",   // HomeKitTypes-Television.js
                characteristic: Characteristic.Identifier,
                props: {format: Characteristic.Formats.UINT32,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ
                               ]
                       },
                validValues: {}
              },
         57:  { type: "ImageMirroring",
                characteristic: Characteristic.ImageMirroring,
                props: {format: Characteristic.Formats.BOOL,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":  true
                   }
              },
         58:  { type: "ImageRotation",
                characteristic: Characteristic.ImageRotation,
                props: {format: Characteristic.Formats.FLOAT,
                        unit: Characteristic.Units.ARC_DEGREE,
                        maxValue: 270,
                        minValue: 0,
                        minStep: 90,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         59:  { type: "InputDeviceType",   // HomeKitTypes-Television.js
                characteristic: Characteristic.InputDeviceType,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 6,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"OTHER":       Characteristic.InputDeviceType.OTHER,
                    "TV":          Characteristic.InputDeviceType.TV,
                    "RECORDING":   Characteristic.InputDeviceType.RECORDING,
                    "TUNER":       Characteristic.InputDeviceType.TUNER,
                    "PLAYBACK":    Characteristic.InputDeviceType.PLAYBACK,
                    "AUDIO_SYSTEM":Characteristic.InputDeviceType.AUDIO_SYSTEM,
                    "UNKNOWN_6":   Characteristic.InputDeviceType.UNKNOWN_6
                   }
              },
         60:  { type: "InputSourceType",   // HomeKitTypes-Television.js
                characteristic: Characteristic.InputSourceType,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 10,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"OTHER":           Characteristic.InputSourceType.OTHER,
                    "HOME_SCREEN":     Characteristic.InputSourceType.HOME_SCREEN,
                    "TUNER":           Characteristic.InputSourceType.TUNER,
                    "HDMI":            Characteristic.InputSourceType.HDMI,
                    "COMPOSITE_VIDEO": Characteristic.InputSourceType.COMPOSITE_VIDEO,
                    "S_VIDEO":         Characteristic.InputSourceType.S_VIDEO,
                    "COMPONENT_VIDEO": Characteristic.InputSourceType.COMPONENT_VIDEO,
                    "DVI":             Characteristic.InputSourceType.DVI,
                    "AIRPLAY":         Characteristic.InputSourceType.AIRPLAY,
                    "USB":             Characteristic.InputSourceType.USB,
                    "APPLICATION":     Characteristic.InputSourceType.APPLICATION
                   }
              },
         61:  { type: "InUse",
                characteristic: Characteristic.InUse,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"NOT_IN_USE": Characteristic.InUse.NOT_IN_USE,
                    "IN_USE":     Characteristic.InUse.IN_USE
                   }
              },
         62:  { type: "IsConfigured",
                characteristic: Characteristic.IsConfigured,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:   // Checked 04/24/2020
                   {"NOT_CONFIGURED": Characteristic.IsConfigured.NOT_CONFIGURED,
                    "CONFIGURED":     Characteristic.IsConfigured.CONFIGURED
                    }
              },
         63:  { type: "LeakDetected",
                characteristic: Characteristic.LeakDetected,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"LEAK_NOT_DETECTED": Characteristic.LeakDetected.LEAK_NOT_DETECTED,
                    "LEAK_DETECTED":     Characteristic.LeakDetected.LEAK_DETECTED
                   }
              },
         64:  { type: "LinkQuality",   // HomeKitTypes-Bridge.js
                characteristic: Characteristic.LinkQuality,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 4,
                        minValue: 1,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         65:  { type: "LockControlPoint",
                characteristic: Characteristic.LockControlPoint,
                props: {format: Characteristic.Formats.TLV8,
                   perms: [Characteristic.Perms.WRITE
                          ]
                       },
                validValues: {}
              },
         66:  { type: "LockCurrentState",
                characteristic: Characteristic.LockCurrentState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 3,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"UNSECURED": Characteristic.LockCurrentState.UNSECURED,
                    "SECURED":   Characteristic.LockCurrentState.SECURED,
                    "JAMMED":    Characteristic.LockCurrentState.JAMMED,
                    "UNKNOWN":   Characteristic.LockCurrentState.UNKNOWN
                   }
              },
         67:  { type: "LockLastKnownAction",
                characteristic: Characteristic.LockLastKnownAction,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 8,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"SECURED_PHYSICALLY_INTERIOR":
                     Characteristic.LockLastKnownAction.SECURED_PHYSICALLY_INTERIOR,
                    "UNSECURED_PHYSICALLY_INTERIOR":
                     Characteristic.LockLastKnownAction.UNSECURED_PHYSICALLY_INTERIOR,
                    "SECURED_PHYSICALLY_EXTERIOR":
                     Characteristic.LockLastKnownAction.SECURED_PHYSICALLY_EXTERIOR,
                    "UNSECURED_PHYSICALLY_EXTERIOR":
                     Characteristic.LockLastKnownAction.UNSECURED_PHYSICALLY_EXTERIOR,
                    "SECURED_BY_KEYPAD":
                     Characteristic.LockLastKnownAction.SECURED_BY_KEYPAD,
                    "UNSECURED_BY_KEYPAD":
                     Characteristic.LockLastKnownAction.UNSECURED_BY_KEYPAD,
                    "SECURED_REMOTELY":
                     Characteristic.LockLastKnownAction.SECURED_REMOTELY,
                    "UNSECURED_REMOTELY":
                     Characteristic.LockLastKnownAction.UNSECURED_REMOTELY,
                    "SECURED_BY_AUTO_SECURE_TIMEOUT":
                     Characteristic.LockLastKnownAction.SECURED_BY_AUTO_SECURE_TIMEOUT
                   }
              },
         68:  { type: "LockManagementAutoSecurityTimeout",
                props: {format: Characteristic.Formats.UINT32,
                        unit: Characteristic.Units.SECONDS,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                characteristic: Characteristic.LockManagementAutoSecurityTimeout,
                validValues: {}
              },
         69:  { type: "LockPhysicalControls",
                characteristic: Characteristic.LockPhysicalControls,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"CONTROL_LOCK_DISABLED": Characteristic.LockPhysicalControls.CONTROL_LOCK_DISABLED,
                    "CONTROL_LOCK_ENABLED":  Characteristic.LockPhysicalControls.CONTROL_LOCK_ENABLED
                   }
              },
         70:  { type: "LockTargetState",
                characteristic: Characteristic.LockTargetState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"UNSECURED": Characteristic.LockTargetState.UNSECURED,
                    "SECURED":   Characteristic.LockTargetState.SECURED
                   }
              },
         71:  { type: "Logs",
                characteristic: Characteristic.Logs,
                props: {format: Characteristic.Formats.TLV8,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         72:  { type: "Manufacturer",
                characteristic: Characteristic.Manufacturer,
                props: {format: Characteristic.Formats.STRING,
                   perms: [Characteristic.Perms.READ
                          ]
                       },
                validValues: {}
              },
         73:  { type: "Model",
                characteristic: Characteristic.Model,
                props: {format: Characteristic.Formats.STRING,
                        perms: [Characteristic.Perms.READ
                               ]
                       },
                validValues: {}
              },
         74:  { type: "MotionDetected",
                characteristic: Characteristic.MotionDetected,
                props: {format: Characteristic.Formats.BOOL,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":  true
                   }
              },
         75:  { type: "Mute",
                characteristic: Characteristic.Mute,
                props: {format: Characteristic.Formats.BOOL,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":  true
                   }
              },
         76:  { type: "Name",
                characteristic: Characteristic.Name,
                props: {format: Characteristic.Formats.STRING,
                   perms: [Characteristic.Perms.READ
                          ]
                       },
                validValues: {}
              },
         77:  { type: "NightVision",
                characteristic: Characteristic.NightVision,
                props: {format: Characteristic.Formats.BOOL,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY,
                                Characteristic.Perms.TIMED_WRITE
                               ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":  true
                   }
              },
         78:  { type: "NitrogenDioxideDensity",
                characteristic: Characteristic.NitrogenDioxideDensity,
                props: {format: Characteristic.Formats.FLOAT,
                        maxValue: 1000,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         79:  { type: "ObstructionDetected",
                characteristic: Characteristic.ObstructionDetected,
                props: {format: Characteristic.Formats.BOOL,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":  true
                   }
              },
         80:  { type: "OccupancyDetected",
                characteristic: Characteristic.OccupancyDetected,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"OCCUPANCY_NOT_DETECTED":
                       Characteristic.OccupancyDetected.OCCUPANCY_NOT_DETECTED,
                    "OCCUPANCY_DETECTED":
                        Characteristic.OccupancyDetected.OCCUPANCY_DETECTED
                   }
              },
         81:  { type: "On",
                characteristic: Characteristic.On,
                props: {format: Characteristic.Formats.BOOL,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":  true
                   }
              },
         82:  { type: "OpticalZoom",
                characteristic: Characteristic.OpticalZoom,
                props: {format: Characteristic.Formats.FLOAT,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         83:  { type: "OutletInUse",
                characteristic: Characteristic.OutletInUse,
                props: {format: Characteristic.Formats.BOOL,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":  true
                   }
              },
         84:  { type: "OzoneDensity",
                characteristic: Characteristic.OzoneDensity,
                props: {format: Characteristic.Formats.FLOAT,
                        maxValue: 1000,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         85:  { type: "PairSetup",
                characteristic: Characteristic.PairSetup,
                props: {format: Characteristic.Formats.TLV8,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE
                               ]
                       },
                validValues: {}
              },
         86:  { type: "PairVerify",
                characteristic: Characteristic.PairVerify,
                props: {format: Characteristic.Formats.TLV8,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE
                               ]
                       },
                validValues: {}
              },
         87:  { type: "PairingFeatures",
                characteristic: Characteristic.PairingFeatures,
                props: {format: Characteristic.Formats.UINT8,
                        perms: [Characteristic.Perms.READ
                               ]
                       },
                validValues: {}
              },
         88:  { type: "PairingPairings",
                characteristic: Characteristic.PairingPairings,
                props: {format: Characteristic.Formats.TLV8,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE
                               ]
                       },
                validValues: {}
              },
         89:  { type: "PictureMode",   // HomeKitTypes-Television.js
                characteristic: Characteristic.PictureMode,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 13,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"OTHER":           Characteristic.PictureMode.OTHER,
                    "STANDARD":        Characteristic.PictureMode.STANDARD,
                    "CALIBRATED":      Characteristic.PictureMode.CALIBRATED,
                    "CALIBRATED_DARK": Characteristic.PictureMode.CALIBRATED_DARK,
                    "VIVID":           Characteristic.PictureMode.VIVID,
                    "GAME":            Characteristic.PictureMode.GAME,
                    "COMPUTER":        Characteristic.PictureMode.COMPUTER,
                    "CUSTOM":          Characteristic.PictureMode.CUSTOM,
                    "UNKNOWN8":        8,
                    "UNKNOWN9":        9,
                    "UNKNOWN10":       10,
                    "UNKNOWN11":       11,
                    "UNKNOWN12":       12,
                    "UNKNOWN13":       13
                   }
              },
         90:  { type: "PM10Density",
                characteristic: Characteristic.PM10Density,
                props: {format: Characteristic.Formats.FLOAT,
                maxValue: 1000,
                minValue: 0,
                minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         91:  { type: "PM2_5Density",
                characteristic: Characteristic.PM2_5Density,
                props: {format: Characteristic.Formats.FLOAT,
                        maxValue: 1000,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         92:  { type: "PositionState",
                characteristic: Characteristic.PositionState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 2,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"DECREASING": Characteristic.PositionState.DECREASING,
                    "INCREASING": Characteristic.PositionState.INCREASING,
                    "STOPPED":    Characteristic.PositionState.STOPPED
                   }
              },
         93:  { type: "PowerModeSelection",  // HomeKitTypes-Television.js
                characteristic: Characteristic.PowerModeSelection,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.WRITE
                               ]
                       },
                validValues:
                   {"SHOW": Characteristic.PowerModeSelection.SHOW,
                    "HIDE": Characteristic.PowerModeSelection.HIDE
                   }
              },
         94:  { type: "ProgramMode",
                characteristic: Characteristic.ProgramMode,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 2,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"NO_PROGRAM_SCHEDULED":
                      Characteristic.ProgramMode.NO_PROGRAM_SCHEDULED,
                    "PROGRAM_SCHEDULED":
                       Characteristic.ProgramMode.PROGRAM_SCHEDULED,
                    "PROGRAM_SCHEDULED_MANUAL_MODE_":
                        Characteristic.ProgramMode.PROGRAM_SCHEDULED_MANUAL_MODE_
                   }
              },
         95:  { type: "ProgrammableSwitchEvent",
                characteristic: Characteristic.ProgrammableSwitchEvent,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 2,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"SINGLE_PRESS": Characteristic.ProgrammableSwitchEvent.SINGLE_PRESS,
                         "DOUBLE_PRESS": Characteristic.ProgrammableSwitchEvent.DOUBLE_PRESS,
                         "LONG_PRESS":   Characteristic.ProgrammableSwitchEvent.LONG_PRESS
                        }
              },
         96:  { type: "ProgrammableSwitchOutputState",   // HomeKitTypes-Bridge.js
                characteristic: Characteristic.ProgrammableSwitchOutputState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         97:  { type: "Reachable",   // HomeKitTypes-Bridge.js
                characteristic: Characteristic.Reachable,
                props: {format: Characteristic.Formats.BOOL,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":  true
                   }
              },
         98:  { type: "RelativeHumidityDehumidifierThreshold",
                props: {format: Characteristic.Formats.FLOAT,
                        maxValue: 100,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                characteristic: Characteristic.RelativeHumidityDehumidifierThreshold,
                validValues: {}
              },
         99:  { type: "RelativeHumidityHumidifierThreshold",
                props: {format: Characteristic.Formats.FLOAT,
                        unit: Characteristic.Units.PERCENTAGE,
                        maxValue: 100,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                characteristic: Characteristic.RelativeHumidityHumidifierThreshold,
                validValues: {}
              },
         100: { type: "RelayEnabled",   // HomeKitTypes-Bridge.js
                characteristic: Characteristic.RelayEnabled,
                props: {format: Characteristic.Formats.BOOL,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":  true
                   }
              },
         101: { type: "RelayState",   // HomeKitTypes-Bridge.js
                characteristic: Characteristic.RelayState,
                props: {format: Characteristic.Formats.UINT8,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         102: { type: "RelayControlPoint",   // HomeKitTypes-Bridge.js
                characteristic: Characteristic.RelayControlPoint,
                props: {format: Characteristic.Formats.TLV8,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         103: { type: "RemainingDuration",
                characteristic: Characteristic.RemainingDuration,
                props: {format: Characteristic.Formats.UINT32,
                        maxValue: 3600,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         104: { type: "RemoteKey",   // HomeKitTypes-Television.js
                characteristic: Characteristic.RemoteKey,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 16,
                        minValue: 0,
                        perms: [Characteristic.Perms.WRITE
                               ]
                       },
                validValues:
                   {"REWIND":         Characteristic.RemoteKey.REWIND,
                    "FAST_FORWARD":   Characteristic.RemoteKey.FAST_FORWARD,
                    "NEXT_TRACK":     Characteristic.RemoteKey.NEXT_TRACK,
                    "PREVIOUS_TRACK": Characteristic.RemoteKey.PREVIOUS_TRACK,
                    "ARROW_UP":       Characteristic.RemoteKey.ARROW_UP,
                    "ARROW_DOWN":     Characteristic.RemoteKey.ARROW_DOWN,
                    "ARROW_LEFT":     Characteristic.RemoteKey.ARROW_LEFT,
                    "ARROW_RIGHT":    Characteristic.RemoteKey.ARROW_RIGHT,
                    "SELECT":         Characteristic.RemoteKey.SELECT,
                    "BACK":           Characteristic.RemoteKey.BACK,
                    "EXIT":           Characteristic.RemoteKey.EXIT,
                    "PLAY_PAUSE":     Characteristic.RemoteKey.PLAY_PAUSE,
                    "UNKNOWN12":      12,  // HomeBridge does not have these defined for values
                    "UNKNOWN13":      13,  // HomeBridge does not have these defined for values
                    "UNKNOWN14":      14,  // HomeBridge does not have these defined for values
                    "INFORMATION":    Characteristic.RemoteKey.INFORMATION,
                    "UNKNOWN16":      16   // HomeBridge does not have these defined for values
                   }
              },
         105: { type: "ResetFilterIndication",
                characteristic: Characteristic.ResetFilterIndication,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 1,
                        minStep: 1,
                        perms: [Characteristic.Perms.WRITE
                               ]
                       },
                validValues: {}
              },
         106: { type: "RotationDirection",
                characteristic: Characteristic.RotationDirection,
                props: {format: Characteristic.Formats.INT,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"CLOCKWISE":
                      Characteristic.RotationDirection.CLOCKWISE,
                    "COUNTER_CLOCKWISE":
                      Characteristic.RotationDirection.COUNTER_CLOCKWISE
                   }
              },
         107: { type: "RotationSpeed",
                characteristic: Characteristic.RotationSpeed,
                props: {format: Characteristic.Formats.FLOAT,
                        unit: Characteristic.Units.PERCENTAGE,
                        maxValue: 100,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         108: { type: "Saturation",
                characteristic: Characteristic.Saturation,
                props: {format: Characteristic.Formats.FLOAT,
                        unit: Characteristic.Units.PERCENTAGE,
                        maxValue: 100,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         109: { type: "SecuritySystemAlarmType",
                characteristic: Characteristic.SecuritySystemAlarmType,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         110: { type: "SecuritySystemCurrentState",
                characteristic: Characteristic.SecuritySystemCurrentState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 4,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"STAY_ARM":
                      Characteristic.SecuritySystemCurrentState.STAY_ARM,
                    "AWAY_ARM":
                       Characteristic.SecuritySystemCurrentState.AWAY_ARM,
                    "NIGHT_ARM":
                       Characteristic.SecuritySystemCurrentState.NIGHT_ARM,
                    "DISARMED":
                       Characteristic.SecuritySystemCurrentState.DISARMED,
                    "ALARM_TRIGGERED":
                       Characteristic.SecuritySystemCurrentState.ALARM_TRIGGERED
                   }
              },
         111: { type: "SecuritySystemTargetState",
                characteristic: Characteristic.SecuritySystemTargetState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 3,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                {"STAY_ARM":  Characteristic.SecuritySystemTargetState.STAY_ARM,
                 "AWAY_ARM":  Characteristic.SecuritySystemTargetState.AWAY_ARM,
                 "NIGHT_ARM": Characteristic.SecuritySystemTargetState.NIGHT_ARM,
                 "DISARM":    Characteristic.SecuritySystemTargetState.DISARM
                }
              },
         112: { type: "SelectedRTPStreamConfiguration",
                characteristic: Characteristic.SelectedRTPStreamConfiguration,
                props: {format: Characteristic.Formats.TLV8,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE
                               ]
                       },
                validValues: {}
              },
         113: { type: "SerialNumber",
                characteristic: Characteristic.SerialNumber,
                props: {format: Characteristic.Formats.STRING,
                        perms: [Characteristic.Perms.READ
                               ]
                       },
                validValues: {}
              },
         114: { type: "ServiceLabelIndex",
                characteristic: Characteristic.ServiceLabelIndex,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 255,
                        minValue: 1,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ
                               ]
                       },
                validValues: {}
              },
         115: { type: "ServiceLabelNamespace",
                characteristic: Characteristic.ServiceLabelNamespace,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ
                               ]
                       },
                validValues:
                   {"DOTS":            Characteristic.ServiceLabelNamespace.DOTS,
                    "ARABIC_NUMERALS": Characteristic.ServiceLabelNamespace.ARABIC_NUMERALS
                   }
              },
         116: { type: "SetDuration",
                characteristic: Characteristic.SetDuration,
                props: {format: Characteristic.Formats.UINT32,
                        maxValue: 3600,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         117: { type: "SetupEndpoints",
                characteristic: Characteristic.SetupEndpoints,
                props: {format: Characteristic.Formats.TLV8,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE
                               ]
                       },
                validValues: {}
              },
         118: { type: "SlatType",
                characteristic: Characteristic.SlatType,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ
                               ]
                       },
                validValues:
                   {"HORIZONTAL": Characteristic.SlatType.HORIZONTAL,
                    "VERTICAL":   Characteristic.SlatType.VERTICAL
                   }
              },
         119: { type: "SleepDiscoveryMode",   // HomeKitTypes-Television.js
                characteristic: Characteristic.SleepDiscoveryMode,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"NOT_DISCOVERABLE":    Characteristic.SleepDiscoveryMode.NOT_DISCOVERABLE ,
                    "ALWAYS_DISCOVERABLE": Characteristic.SleepDiscoveryMode.ALWAYS_DISCOVERABLE
                   }
              },
         120: { type: "SmokeDetected",
                characteristic: Characteristic.SmokeDetected,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                                ]
                       },
                validValues:
                   {"SMOKE_NOT_DETECTED": Characteristic.SmokeDetected.SMOKE_NOT_DETECTED,
                    "SMOKE_DETECTED":     Characteristic.SmokeDetected.SMOKE_DETECTED
                   }
              },
         121: { type: "StatusActive",
                characteristic: Characteristic.StatusActive,
                props: {format: Characteristic.Formats.BOOL,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"FALSE": false,
                     "TRUE":  true
                   }
              },
         122: { type: "StatusFault",
                characteristic: Characteristic.StatusFault,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"NO_FAULT":      Characteristic.StatusFault.NO_FAULT,
                     "GENERAL_FAULT": Characteristic.StatusFault.GENERAL_FAULT
                   }
              },
         123: { type: "StatusJammed",
                characteristic: Characteristic.StatusJammed,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"NOT_JAMMED": Characteristic.StatusJammed.NOT_JAMMED,
                    "JAMMED":     Characteristic.StatusJammed.JAMMED
                   }
              },
         124: { type: "StatusLowBattery",
                characteristic: Characteristic.StatusLowBattery,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"BATTERY_LEVEL_NORMAL":
                      Characteristic.StatusLowBattery.BATTERY_LEVEL_NORMAL,
                    "BATTERY_LEVEL_LOW":
                      Characteristic.StatusLowBattery.BATTERY_LEVEL_LOW
                   }
              },
         125: { type: "StatusTampered",
                characteristic: Characteristic.StatusTampered,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"NOT_TAMPERED": Characteristic.StatusTampered.NOT_TAMPERED,
                    "TAMPERED":     Characteristic.StatusTampered.TAMPERED
                   }
              },
         126: { type: "StreamingStatus",
                characteristic: Characteristic.StreamingStatus,
                props: {format: Characteristic.Formats.TLV8,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         127: { type: "SulphurDioxideDensity",
                characteristic: Characteristic.SulphurDioxideDensity,
                props: {format: Characteristic.Formats.FLOAT,
                        maxValue: 1000,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         128: { type: "SupportedAudioStreamConfiguration",
                characteristic: Characteristic.SupportedAudioStreamConfiguration,
                props: {format: Characteristic.Formats.TLV8,
                        perms: [Characteristic.Perms.READ
                               ]
                       },
                validValues: {}
              },
         129: { type: "SupportedRTPConfiguration",
                characteristic: Characteristic.SupportedRTPConfiguration,
                props: {format: Characteristic.Formats.TLV8,
                        perms: [Characteristic.Perms.READ
                               ]
                       },
                validValues: {}
              },
         130: { type: "SupportedVideoStreamConfiguration",
                characteristic: Characteristic.SupportedVideoStreamConfiguration,
                props: {format: Characteristic.Formats.TLV8,
                        perms: [Characteristic.Perms.READ
                               ]
                       },
                validValues: {}
              },
         131: { type: "SwingMode",
                characteristic: Characteristic.SwingMode,

                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
               validValues:
                  {"SWING_DISABLED": Characteristic.SwingMode.SWING_DISABLED,
                   "SWING_ENABLED": Characteristic.SwingMode.SWING_ENABLED
                  }
              },
         132: { type: "TargetAirPurifierState",
                characteristic: Characteristic.TargetAirPurifierState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:   // Checked 04/24/2020
                   {"MANUAL": Characteristic.TargetAirPurifierState.MANUAL,
                    "AUTO":   Characteristic.TargetAirPurifierState.AUTO
                   }
              },
         133: { type: "TargetAirQuality",
                characteristic: Characteristic.TargetAirQuality,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 2,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"EXCELLENT": Characteristic.TargetAirQuality.EXCELLENT,
                    "GOOD":      Characteristic.TargetAirQuality.GOOD,
                    "FAIR":      Characteristic.TargetAirQuality.FAIR
                   }
              },
         134: { type: "TargetDoorState",
                characteristic: Characteristic.TargetDoorState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"OPEN":   Characteristic.TargetDoorState.OPEN,
                    "CLOSED": Characteristic.TargetDoorState.CLOSED
                   }
              },
         135: { type: "TargetFanState",
                characteristic: Characteristic.TargetFanState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"MANUAL": Characteristic.TargetFanState.MANUAL,
                    "AUTO": Characteristic.TargetFanState.AUTO
                   }
              },
         136: { type: "TargetHeaterCoolerState",
                characteristic: Characteristic.TargetHeaterCoolerState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 2,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"AUTO": Characteristic.TargetHeaterCoolerState.AUTO,
                    "HEAT": Characteristic.TargetHeaterCoolerState.HEAT,
                    "COOL": Characteristic.TargetHeaterCoolerState.COOL
                   }
              },
         137: { type: "TargetHeatingCoolingState",
                characteristic: Characteristic.TargetHeatingCoolingState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 3,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"OFF": Characteristic.TargetHeatingCoolingState.OFF,
                    "HEAT": Characteristic.TargetHeatingCoolingState.HEAT,
                    "COOL": Characteristic.TargetHeatingCoolingState.COOL,
                    "AUTO": Characteristic.TargetHeatingCoolingState.AUTO
                   }
              },
         138: { type: "TargetHorizontalTiltAngle",
                characteristic: Characteristic.TargetHorizontalTiltAngle,
                props: {format: Characteristic.Formats.INT,
                        unit: Characteristic.Units.ARC_DEGREE,
                        maxValue: 90,
                        minValue: -90,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         139: { type: "TargetHumidifierDehumidifierState",
                characteristic: Characteristic.TargetHumidifierDehumidifierState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 2,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                  {"HUMIDIFIER_OR_DEHUMIDIFIER":
                     Characteristic.TargetHumidifierDehumidifierState.HUMIDIFIER_OR_DEHUMIDIFIER,
                   "HUMIDIFIER":
                     Characteristic.TargetHumidifierDehumidifierState.HUMIDIFIER,
                   "DEHUMIDIFIER":
                     Characteristic.TargetHumidifierDehumidifierState.DEHUMIDIFIER
                  }
              },
         140: { type: "TargetMediaState",   // HomeKitTypes-Television.js
                characteristic: Characteristic.TargetMediaState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 2,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"PLAY": Characteristic.TargetMediaState.PLAY,
                    "PAUSE": Characteristic.TargetMediaState.PAUSE,
                    "STOP": Characteristic.TargetMediaState.STOP,
                    "UNKNOWN3": 3   // HomeBridge has an extra
                   }
              },
         141: { type: "TargetPosition",
                characteristic: Characteristic.TargetPosition,
                props: {format: Characteristic.Formats.UINT8,
                        unit: Characteristic.Units.PERCENTAGE,
                        maxValue: 100,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         142: { type: "TargetRelativeHumidity",
                characteristic: Characteristic.TargetRelativeHumidity,
                props: {format: Characteristic.Formats.FLOAT,
                        unit: Characteristic.Units.PERCENTAGE,
                        maxValue: 100,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         143: { type: "TargetSlatState",
                characteristic: Characteristic.TargetSlatState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"MANUAL": Characteristic.TargetSlatState.MANUAL,
                    "AUTO":   Characteristic.TargetSlatState.AUTO
                   }
              },
         144: { type: "TargetTemperature",
                characteristic: Characteristic.TargetTemperature,
                props: {format: Characteristic.Formats.FLOAT,
                        unit: Characteristic.Units.CELSIUS,
                        maxValue: 38,
                        minValue: 10,
                        minStep: 0.1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         145: { type: "TargetTiltAngle",
                characteristic: Characteristic.TargetTiltAngle,
                props: {format: Characteristic.Formats.INT,
                        unit:   Characteristic.Units.ARC_DEGREE,
                        maxValue:  90,
                        minValue: -90,
                        minStep:   1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         146: { type: "TargetVerticalTiltAngle",
                characteristic: Characteristic.TargetVerticalTiltAngle,
                props: {format: Characteristic.Formats.INT,
                        unit: Characteristic.Units.ARC_DEGREE,
                        maxValue: 90,
                        minValue: -90,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         147: { type: "TargetVisibilityState",   // HomeKittypes-Television.js
                characteristic: Characteristic.TargetVisibilityState,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"SHOWN": Characteristic.TargetVisibilityState.SHOWN,
                    "HIDDEN": Characteristic.TargetVisibilityState.HIDDEN
                   }
              },
         148: { type: "TemperatureDisplayUnits",
                characteristic: Characteristic.TemperatureDisplayUnits,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"CELSIUS":    Characteristic.TemperatureDisplayUnits.CELSIUS,
                    "FAHRENHEIT": Characteristic.TemperatureDisplayUnits.FAHRENHEIT
                    }
              },
         149: { type: "TimeUpdate",   // HomeKitTypes-Bridge.js
                characteristic: Characteristic.TimeUpdate,
                props: {format: Characteristic.Formats.BOOL,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":  true
                   }
              },
         150: { type: "TunneledAccessoryAdvertising",   // HomeKitTypes-Bridge.js
                characteristic: Characteristic.TunneledAccessoryAdvertising,
                props: {format: Characteristic.Formats.BOOL,
                        perms: [Characteristic.Perms.WRITE,   // Reversed in HomeBridge
                                Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":  true
                   }
              },
         151: { type: "TunneledAccessoryConnected",   // HomeKitTypes-Bridge.js
                characteristic: Characteristic.TunneledAccessoryConnected,
                props: {format: Characteristic.Formats.BOOL,
                        perms: [Characteristic.Perms.WRITE,   // Reversed in HomeBridge
                                Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"FALSE": false,
                    "TRUE":  true
                   }
              },
         152: { type: "TunneledAccessoryStateNumber",   // HomeKitTypes-Bridge.js
                characteristic: Characteristic.TunneledAccessoryStateNumber,
                props: {format: Characteristic.Formats.FLOAT,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         153: { type: "TunnelConnectionTimeout",   // HomeKitTypes-Bridge.js
                characteristic: Characteristic.TunnelConnectionTimeout,
                props: {format: Characteristic.Formats.UINT32,
                        perms: [Characteristic.Perms.WRITE,    // Reversed in HomeBridge
                                Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         154: { type: "ValveType",
                characteristic: Characteristic.ValveType,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 3,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"GENERIC_VALVE": Characteristic.ValveType.GENERIC_VALVE,
                    "IRRIGATION":    Characteristic.ValveType.IRRIGATION,
                    "SHOWER_HEAD":   Characteristic.ValveType.SHOWER_HEAD,
                    "WATER_FAUCET":  Characteristic.ValveType.WATER_FAUCET
                   }
              },
         155: { type: "Version",
                characteristic: Characteristic.Version,
                props: {format: Characteristic.Formats.STRING,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         156: { type: "VOCDensity",
                characteristic: Characteristic.VOCDensity,
                props: {format: Characteristic.Formats.FLOAT,
                        maxValue: 1000,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         157: { type: "Volume",
                characteristic: Characteristic.Volume,
                props: {format: Characteristic.Formats.UINT8,
                        unit: Characteristic.Units.PERCENTAGE,
                        maxValue: 100,
                        minValue: 0,
                        minStep: 1,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.WRITE,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              },
         158: { type: "VolumeControlType",   // HomeKitTypes-Television.js
                characteristic: Characteristic.VolumeControlType,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 3,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues:
                   {"NONE":
                       Characteristic.VolumeControlType.NONE,
                    "RELATIVE":
                       Characteristic.VolumeControlType.RELATIVE,
                    "RELATIVE_WITH_CURRENT":
                       Characteristic.VolumeControlType.RELATIVE_WITH_CURRENT,
                    "ABSOLUTE":
                       Characteristic.VolumeControlType.ABSOLUTE
                    }
              },
         159: { type: "VolumeSelector",   // HomeKitTypes-Television.js
                characteristic: Characteristic.VolumeSelector,
                props: {format: Characteristic.Formats.UINT8,
                        maxValue: 1,
                        minValue: 0,
                        perms: [Characteristic.Perms.WRITE
                               ]
                       },
                validValues:
                   {"INCREMENT": Characteristic.VolumeSelector.INCREMENT,
                    "DECREMENT": Characteristic.VolumeSelector.DECREMENT
                   }
              },
         160: { type: "WaterLevel",
                characteristic: Characteristic.WaterLevel,
                props: {format: Characteristic.Formats.FLOAT,
                        maxValue: 100,
                        minValue: 0,
                        perms: [Characteristic.Perms.READ,
                                Characteristic.Perms.NOTIFY
                               ]
                       },
                validValues: {}
              }
      };

      return CMD4_ACC_TYPE_ENUM;
   }, CMD4_ACC_TYPE_ENUM
}
